/*---------------------------------------------------------------------------------
 bbEdgeHook ( 2004 Slade Taylor [bladestaylor@yahoo.com])
 ----------------------------------------------------------------------------------
 bbEdgeHook is a plugin for Blackbox for Windows.  For more information,
 please visit [http://bb4win.org] or [http://sourceforge.net/projects/bb4win].
 ----------------------------------------------------------------------------------
 bbEdgeHook is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

#ifndef _WIN32_WINNT
    #define _WIN32_WINNT 0x0500
#endif

#define VC_EXTRALEAN

#include <windows.h>

// --- from BBApi --------------------------------
#define             MAX_LINE_LENGTH         1024
#define             BB_REGISTERMESSAGE      10001
#define             BB_UNREGISTERMESSAGE    10002
#define             BB_RECONFIGURE          10103
#define             BB_BROADCAST            10901
#define             BB_MENU                 10301
#define             BB_WORKSPACE            10505
#define             BB_WINDOWCLOSE          10615
#define             BBWS_DESKLEFT           0
#define             BBWS_DESKRIGHT          1
#define             BBWS_GATHERWINDOWS      5
#define             BBWS_MOVEWINDOWLEFT     6
#define             BBWS_MOVEWINDOWRIGHT    7
// -----------------------------------------------

//---------------------------------------------------------------------------------

enum PLUGIN_INFO { NAME_VERSION = 0, APPNAME, VERSION, AUTHOR, RELEASEDATE, WEBLINK, EMAIL };

extern "C"
{
    __declspec(dllexport) void      endPlugin(HINSTANCE);
    __declspec(dllexport) int       beginPlugin(HINSTANCE);

    __declspec(dllexport) LPCSTR    pluginInfo(int x)
    {
        switch (x)
        {
            case APPNAME:       return "bbEdgeHook";
            case VERSION:       return "0.0.2";
            case AUTHOR:        return "bladestaylor";
            case RELEASEDATE:   return "May 25, 2004";
            case WEBLINK:       return "http://bb4win.sourceforge.net/bladestaylor/";
            case EMAIL:         return "bladestaylor@yahoo.com";
            default:            return "bbEdgeHook 0.0.2";
        }
    };
}

//---------------------------------------------------------------------------------

bool WINAPI         DllMain(HINSTANCE, DWORD, LPVOID);
LRESULT CALLBACK    MouseProc(int, WPARAM, LPARAM);
LRESULT CALLBACK    PluginProc(HWND, UINT, WPARAM, LPARAM);
void                GetScreenSettings();
void                ProcessBroam(char*);
void                ForceForegroundWindow(HWND);
bool                IsValid(const MOUSEHOOKSTRUCT*);
bool                ProcessMousewheel(POINT, bool);
bool                CheckHittest(UINT);
bool                IsWin2k();
void                ManageDTHook();
bool                xutil_Initialize(char*);
void                xutil_Unload();
void                xutil_RC();

//---------------------------------------------------------------------------------

static HINSTANCE    hInstance = NULL;
//---------------------------------------
#pragma data_seg( ".shared" )
//---------------------------------------
static int          bb_messages[] = {BB_BROADCAST, BB_RECONFIGURE, 0};
static HHOOK        hMouseHook = NULL;
static HWND         hCoreWnd = NULL;
static HWND         hPluginWnd = NULL;
static DWORD        BBThread = 0;
static RECT         ExclusionRect = {0,0,0,0};
static RECT         MarginRect = {0,0,0,0};
static bool         ReverseDirection = false;
static bool         EnableMarginMouseWheel = true;
static bool         EnableTitlebarMouseWheel = true;
static bool         EnableGestures = true;
static bool         EnableSystemMenu = true;
static int          GestureStart = -1;
static bool         bInTitlebar = false;
static bool         bWin2k = false;
static bool         bDTHook = false;
static POINT        Direction_Window = {0,0};
static POINT        Direction_Desk = {0,0};
static void         (*xutil_pEnd)() = NULL;
static void         (*xutil_pStart)() = NULL;
static void         (*xutil_pRC_Int)(char*, char*, long*, int) = NULL;
static void         (*xutil_pRC_Bool)(char*, char*, bool*, bool) = NULL;
static HMODULE      xutil_hmodule = NULL;
//---------------------------------------
#pragma data_seg()
#pragma comment(linker, "/SECTION:.shared,RWS")
//---------------------------------------

//---------------------------------------------------------------------------------


