/*---------------------------------------------------------------------------------
 ID_Item ( 2004 Slade Taylor [bladestaylor@yahoo.com])
 ----------------------------------------------------------------------------------
 ID_Item is a class for Blackbox for Windows.  For more information,
 please visit [http://bb4win.org] or [http://sourceforge.net/projects/bb4win].
 ----------------------------------------------------------------------------------
 ID_Item is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

class Menu;
struct tasklist;

//---------------------------------------------------------------------------------

class ID_Item
{
public:
    static ID_Item  *ListStartup();
    static void     ListShutdown();

    //--------------------------

    void            CleanList();
    void            PushBack(HWND);
    void            XDelMenu(Menu*);
    bool            SetUpdateID(HWND, int);
    Menu            *XMakeMenu(LPSTR, bool);
    int             SetCurrentIDCounter(bool);

    //--------------------------

private:
    ID_Item(HWND);
    ~ID_Item();
    ID_Item         *Erase();

    //--------------------------

    static bool     m_idEnabled;
    static tasklist *(*m_pGetTaskListPtr)();
    static Menu     *(*m_pMakeNamedMenu)(LPCSTR, LPCSTR, bool);
    static int      m_unique_id_counter;
    static int      m_update_id_counter;
    static int      *m_p_current_counter;
    static ID_Item  *m_p_head;

    //--------------------------

    HWND            m_hwnd;
    UINT            m_id;
    ID_Item         *m_next;
};

//---------------------------------------------------------------------------------
