/*---------------------------------------------------------------------------------
 SystemMenuItem ( 2004 Slade Taylor [bladestaylor@yahoo.com])
 ----------------------------------------------------------------------------------
 SystemMenuItem is a class for Blackbox for Windows.  For more information,
 please visit [http://bb4win.org] or [http://sourceforge.net/projects/bb4win].
 ----------------------------------------------------------------------------------
 SystemMenuItem is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

#include "ID_Item.h"

class Menu;
class StyleItem;

//---------------------------------------------------------------------------------

class SystemMenuItem
{
public:
    static void         Startup();
    static void         Shutdown();

    //----------------------------------

    void Reconfig();
    void ProcessBroam(LPARAM);
    void ShowTaskMenu(HWND, bool);

    //----------------------------------

    const static int    MSG_SYSTEM_MENU_SHOW = 55001;

    //----------------------------------

private:
    SystemMenuItem();
    ~SystemMenuItem();

    //----------------------------------

    const static int    TB_MAX = 200;

    //----------------------------------

    struct TaskMenuLine
    {
        char            m_buf[TB_MAX];
        HMENU           m_hsubmenu;
        int             m_id;
        int             m_state;
    };

    //----------------------------------

    void UpdateMenu(HWND, int);
    int GetItemLength(char*, SIZE*);
    void CleanMenuItem(char*, UINT);
    void GetItemText(HMENU, int*, int, char*);
    Menu *MakeSystemSubmenu(HWND, char*, HMENU, bool, int);
    int GetTaskMenuInfo(HWND, HMENU*, TaskMenuLine**, int*, bool*);
    void PickTaskMenuItem(HWND, Menu*, HMENU, int, int, int, char*, bool*, bool, int);

    //----------------------------------

    static void         *(*m_pGetSettingPtr)(int);
    static HFONT        (*m_pCreateStyleFont)(StyleItem*);

    //----------------------------------

    ID_Item             *m_p_ID;
    HWND                m_hwnd;
    HWND                m_hCoreWnd;
    HINSTANCE           m_hinstance;
    DWORD               m_bbThread;
    char                tm_buf[TB_MAX];
    char                tm_buf_data[TB_MAX + 100];
    HDC                 m_hdc;
    Menu                *m_bbMenu;
    HFONT               m_defFont;      // the "default font that comes with the DC
    HFONT               m_iniFont;      // the initial, dummy font
    HFONT               m_frameFont;    // for menu.frame
    HFONT               m_titleFont;    // for menu.title
    MENUITEMINFO        m_menuInfo;

    //----------------------------------
};

//---------------------------------------------------------------------------------
